#include <algorithm>
#include <functional>
#include <vector>
#include <iostream>
using namespace std;

// Function template to populate a container of ints.
// The container must support push_back().
template<typename Container>
void populateContainer(Container& cont)
{
	int num;

	while (true) {
		cout << "Enter a number (0 to quit): ";
		cin >> num;
		if (num == 0) {
			break;
		}
		cont.push_back(num);
	}
}

class SumAndProd : public unary_function<int, void>
{
public:
	SumAndProd() : mSum(0), mProd(1) {}
	void operator()(int elem);
	int getSum() const { return mSum; }
	int getProduct() const { return mProd; }

private:
	int mSum;
	int mProd;
};

void SumAndProd::operator()(int elem)
{
	mSum += elem;
	mProd *= elem;
}

int main()
{
	vector<int> myVector;
	populateContainer(myVector);

	SumAndProd func;
	func = for_each(cbegin(myVector), cend(myVector), func);
	cout << "The sum is " << func.getSum() << endl;
	cout << "The product is " << func.getProduct() << endl;

	return 0;
}
